<?php
/**
 * Carpenter Workshop functions and definitions
 *
 * @package Carpenter Workshop
 * @subpackage carpenter_workshop
 */

function carpenter_workshop_setup() {

	load_theme_textdomain( 'carpenter-workshop', get_template_directory() . '/language' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'woocommerce' );
	add_theme_support( 'title-tag' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'wp-block-styles' );
	add_theme_support( 'align-wide' );
	add_theme_support( 'post-thumbnails' );
	add_image_size( 'carpenter-workshop-featured-image', 2000, 1200, true );
	add_image_size( 'carpenter-workshop-thumbnail-avatar', 100, 100, true );

	// Set the default content width.
	$GLOBALS['content_width'] = 525;

	// This theme uses wp_nav_menu() in two locations.
	register_nav_menus( array(
		'primary-menu'    => __( 'Primary Menu', 'carpenter-workshop' ),
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height'  => true,
	) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support( 'custom-background', array(
		'default-color' => 'ffffff'
	) );

	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio',) );

	add_theme_support( 'html5', array('comment-form','comment-list','gallery','caption',) );

	add_theme_support( 'custom-header', apply_filters( 'carpenter_workshop_custom_header_args', array(
        'default-text-color' => 'fff',
        'header-text'        => false,
        'width'              => 1600,
        'height'             => 350,
        'flex-width'         => true,
        'flex-height'        => true,
        'wp-head-callback'   => 'carpenter_workshop_header_style',
        'default-image'      => get_template_directory_uri() . '/assets/images/sliderimage.png',
    ) ) );

	/**
	 * Implement the Custom Header feature.
	 */
	require get_parent_theme_file_path( '/inc/custom-header.php' );


}
add_action( 'after_setup_theme', 'carpenter_workshop_setup' );

// Add function after setup:
function carpenter_workshop_conditional_editor_styles() {
	
	add_editor_style( array( 'assets/css/editor-style.css', carpenter_workshop_fonts_url() ) );
}
add_action( 'after_setup_theme', 'carpenter_workshop_conditional_editor_styles', 11 );

/**
 * Register custom fonts.
 */
function carpenter_workshop_fonts_url(){
	$carpenter_workshop_font_url = '';
	$carpenter_workshop_font_family = array();
	$carpenter_workshop_font_family[] = 'Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Raleway:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Bad Script';
	$carpenter_workshop_font_family[] = 'Bebas Neue';
	$carpenter_workshop_font_family[] = 'Fjalla One';
	$carpenter_workshop_font_family[] = 'PT Sans:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'PT Serif:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900';
	$carpenter_workshop_font_family[] = 'Roboto Condensed:ital,wght@0,300;0,400;0,700;1,300;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Alex Brush';
	$carpenter_workshop_font_family[] = 'Overpass:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Playball';
	$carpenter_workshop_font_family[] = 'Alegreya:ital,wght@0,400;0,500;0,600;0,700;0,800;0,900;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Julius Sans One';
	$carpenter_workshop_font_family[] = 'Arsenal:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Slabo 13px';
	$carpenter_workshop_font_family[] = 'Lato:ital,wght@0,100;0,300;0,400;0,700;0,900;1,100;1,300;1,400;1,700;1,900';
	$carpenter_workshop_font_family[] = 'Overpass Mono:wght@300;400;500;600;700';
	$carpenter_workshop_font_family[] = 'Source Sans Pro:ital,wght@0,200;0,300;0,400;0,600;0,700;0,900;1,200;1,300;1,400;1,600;1,700;1,900';
	$carpenter_workshop_font_family[] = 'Raleway:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Merriweather:ital,wght@0,300;0,400;0,700;0,900;1,300;1,400;1,700;1,900';
	$carpenter_workshop_font_family[] = 'Rubik:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Lora:ital,wght@0,400;0,500;0,600;0,700;1,400;1,500;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Ubuntu:ital,wght@0,300;0,400;0,500;0,700;1,300;1,400;1,500;1,700';
	$carpenter_workshop_font_family[] = 'Cabin:ital,wght@0,400;0,500;0,600;0,700;1,400;1,500;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Arimo:ital,wght@0,400;0,500;0,600;0,700;1,400;1,500;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Playfair Display:ital,wght@0,400;0,500;0,600;0,700;0,800;0,900;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Quicksand:wght@300;400;500;600;700';
	$carpenter_workshop_font_family[] = 'Padauk:wght@400;700';
	$carpenter_workshop_font_family[] = 'Mulish:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;0,1000;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900;1,1000';
	$carpenter_workshop_font_family[] = 'Inconsolata:wght@200;300;400;500;600;700;800;900&family=Mulish:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;0,1000;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900;1,1000';
	$carpenter_workshop_font_family[] = 'Bitter:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&family=Mulish:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;0,1000;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900;1,1000';
	$carpenter_workshop_font_family[] = 'Pacifico';
	$carpenter_workshop_font_family[] = 'Indie Flower';
	$carpenter_workshop_font_family[] = 'VT323';
	$carpenter_workshop_font_family[] = 'Dosis:wght@200;300;400;500;600;700;800';
	$carpenter_workshop_font_family[] = 'Frank Ruhl Libre:wght@300;400;500;700;900';
	$carpenter_workshop_font_family[] = 'Fjalla One';
	$carpenter_workshop_font_family[] = 'Figtree:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Oxygen:wght@300;400;700';
	$carpenter_workshop_font_family[] = 'Arvo:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Noto Serif:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Lobster';
	$carpenter_workshop_font_family[] = 'Crimson Text:ital,wght@0,400;0,600;0,700;1,400;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Yanone Kaffeesatz:wght@200;300;400;500;600;700';
	$carpenter_workshop_font_family[] = 'Anton';
	$carpenter_workshop_font_family[] = 'Libre Baskerville:ital,wght@0,400;0,700;1,400';
	$carpenter_workshop_font_family[] = 'Bree Serif';
	$carpenter_workshop_font_family[] = 'Gloria Hallelujah';
	$carpenter_workshop_font_family[] = 'Abril Fatface';
	$carpenter_workshop_font_family[] = 'Varela Round';
	$carpenter_workshop_font_family[] = 'Vampiro One';
	$carpenter_workshop_font_family[] = 'Shadows Into Light';
	$carpenter_workshop_font_family[] = 'Cuprum:ital,wght@0,400;0,500;0,600;0,700;1,400;1,500;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Rokkitt:wght@100;200;300;400;500;600;700;800;900';
	$carpenter_workshop_font_family[] = 'Vollkorn:ital,wght@0,400;0,500;0,600;0,700;0,800;0,900;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Francois One';
	$carpenter_workshop_font_family[] = 'Orbitron:wght@400;500;600;700;800;900';
	$carpenter_workshop_font_family[] = 'Patua One';
	$carpenter_workshop_font_family[] = 'Acme';
	$carpenter_workshop_font_family[] = 'Satisfy';
	$carpenter_workshop_font_family[] = 'Josefin Slab:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;1,100;1,200;1,300;1,400;1,500;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Quattrocento Sans:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Architects Daughter';
	$carpenter_workshop_font_family[] = 'Russo One';
	$carpenter_workshop_font_family[] = 'Monda:wght@400;700';
	$carpenter_workshop_font_family[] = 'Righteous';
	$carpenter_workshop_font_family[] = 'Lobster Two:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Hammersmith One';
	$carpenter_workshop_font_family[] = 'Courgette';
	$carpenter_workshop_font_family[] = 'Permanent Marke';
	$carpenter_workshop_font_family[] = 'Cherry Swash:wght@400;700';
	$carpenter_workshop_font_family[] = 'Cormorant Garamond:ital,wght@0,300;0,400;0,500;0,600;0,700;1,300;1,400;1,500;1,600;1,700';
	$carpenter_workshop_font_family[] = 'Poiret One';
	$carpenter_workshop_font_family[] = 'BenchNine:wght@300;400;700';
	$carpenter_workshop_font_family[] = 'Economica:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Handlee';
	$carpenter_workshop_font_family[] = 'Cardo:ital,wght@0,400;0,700;1,400';
	$carpenter_workshop_font_family[] = 'Alfa Slab One';
	$carpenter_workshop_font_family[] = 'Averia Serif Libre:ital,wght@0,300;0,400;0,700;1,300;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Cookie';
	$carpenter_workshop_font_family[] = 'Chewy';
	$carpenter_workshop_font_family[] = 'Great Vibes';
	$carpenter_workshop_font_family[] = 'Coming Soon';
	$carpenter_workshop_font_family[] = 'Philosopher:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Days One';
	$carpenter_workshop_font_family[] = 'Kanit:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Shrikhand';
	$carpenter_workshop_font_family[] = 'Tangerine:wght@400;700';
	$carpenter_workshop_font_family[] = 'IM Fell English SC';
	$carpenter_workshop_font_family[] = 'Boogaloo';
	$carpenter_workshop_font_family[] = 'Bangers';
	$carpenter_workshop_font_family[] = 'Fredoka One';
	$carpenter_workshop_font_family[] = 'Volkhov:ital,wght@0,400;0,700;1,400;1,700';
	$carpenter_workshop_font_family[] = 'Shadows Into Light Two';
	$carpenter_workshop_font_family[] = 'Marck Script';
	$carpenter_workshop_font_family[] = 'Sacramento';
	$carpenter_workshop_font_family[] = 'Unica One';
	$carpenter_workshop_font_family[] = 'Dancing Script:wght@400;500;600;700';
	$carpenter_workshop_font_family[] = 'Exo 2:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Archivo:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'Jost:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900';
	$carpenter_workshop_font_family[] = 'DM Serif Display:ital@0;1';
	$carpenter_workshop_font_family[] = 'Open Sans:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;1,300;1,400;1,500;1,600;1,700;1,800';

	$carpenter_workshop_query_args = array(
		'family'	=> rawurlencode(implode('|',$carpenter_workshop_font_family)),
	);
	$carpenter_workshop_font_url = add_query_arg($carpenter_workshop_query_args,'//fonts.googleapis.com/css');
	return $carpenter_workshop_font_url;
	$contents = carpenter_workshop_carpenter_workshop_wptt_get_webfont_url( esc_url_raw( $carpenter_workshop_font_url ) );
}

// Category count 
function carpenter_workshop_display_post_category_count() {
    $carpenter_workshop_category = get_the_category();
    $carpenter_workshop_category_count = ($carpenter_workshop_category) ? count($carpenter_workshop_category) : 0;
    $carpenter_workshop_category_text = ($carpenter_workshop_category_count === 1) ? 'category' : 'categories'; // Check for pluralization
    echo $carpenter_workshop_category_count . ' ' . $carpenter_workshop_category_text;
}

//post tag
function carpenter_workshop_custom_tags_filter($carpenter_workshop_tag_list) {
    // Replace the comma (,) with an empty string
    $carpenter_workshop_tag_list = str_replace(', ', '', $carpenter_workshop_tag_list);

    return $carpenter_workshop_tag_list;
}
add_filter('the_tags', 'carpenter_workshop_custom_tags_filter');

function carpenter_workshop_custom_output_tags() {
    $carpenter_workshop_tags = get_the_tags();

    if ($carpenter_workshop_tags) {
        $carpenter_workshop_tags_output = '<div class="post_tag">Tags: ';

        $carpenter_workshop_first_tag = reset($carpenter_workshop_tags);

        foreach ($carpenter_workshop_tags as $tag) {
            $carpenter_workshop_tags_output .= '<a href="' . esc_url(get_tag_link($tag)) . '" rel="tag" class="mr-2">' . esc_html($tag->name) . '</a>';
            if ($tag !== $carpenter_workshop_first_tag) {
                $carpenter_workshop_tags_output .= ' ';
            }
        }
        $carpenter_workshop_tags_output .= '</div>';
        echo $carpenter_workshop_tags_output;
    }
}
/**
 * Register widget area.
 */
function carpenter_workshop_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Blog Sidebar', 'carpenter-workshop' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'carpenter-workshop' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your sidebar on pages.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'carpenter-workshop' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 1', 'carpenter-workshop' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s p-3">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'carpenter-workshop' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s p-3">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'carpenter-workshop' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s p-3">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'carpenter-workshop' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'carpenter-workshop' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s p-3">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'carpenter_workshop_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function carpenter_workshop_scripts() {
	// Add custom fonts, used in the main stylesheet.
	wp_enqueue_style( 'carpenter-workshop-fonts', carpenter_workshop_fonts_url(), array(), null );

	// Bootstrap
	wp_enqueue_style( 'bootstrap-css', get_theme_file_uri( '/assets/css/bootstrap.css' ) );

	// owl
	wp_enqueue_style( 'owl-carousel-css', get_theme_file_uri( '/assets/css/owl.carousel.css' ) );

	// Theme stylesheet.
	wp_enqueue_style( 'carpenter-workshop-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/tp-body-width-layout.php' );
	wp_add_inline_style( 'carpenter-workshop-style',$carpenter_workshop_tp_theme_css );
	wp_enqueue_style( 'carpenter-workshop-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/tp-theme-color.php' );
	wp_add_inline_style( 'carpenter-workshop-style',$carpenter_workshop_tp_theme_css );
	wp_style_add_data('carpenter-workshop-style', 'rtl', 'replace');

	// Theme stylesheet.
	wp_enqueue_style( 'carpenter-workshop-style', get_stylesheet_uri() );

	// Theme block stylesheet.
	wp_enqueue_style( 'carpenter-workshop-block-style', get_theme_file_uri( '/assets/css/blocks.css' ), array( 'carpenter-workshop-style' ), '1.0' );

	// Fontawesome
	wp_enqueue_style( 'fontawesome-css', get_theme_file_uri( '/assets/css/fontawesome-all.css' ) );

	wp_enqueue_script( 'bootstrap-js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ), true );

	wp_enqueue_script( 'owl-carousel-js', get_theme_file_uri( '/assets/js/owl.carousel.js' ), array( 'jquery' ), true );

	wp_enqueue_script( 'carpenter-workshop-custom-scripts', esc_url( get_template_directory_uri() ) . '/assets/js/custom.js', array('jquery'), true );

	wp_enqueue_script( 'carpenter-workshop-focus-nav', esc_url( get_template_directory_uri() ) . '/assets/js/focus-nav.js', array('jquery'), true);

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	$carpenter_workshop_body_font_family = get_theme_mod('carpenter_workshop_body_font_family', '');

	$carpenter_workshop_heading_font_family = get_theme_mod('carpenter_workshop_heading_font_family', '');

	$carpenter_workshop_menu_font_family = get_theme_mod('carpenter_workshop_menu_font_family', '');

	$carpenter_workshop_tp_theme_css = '
		body{
		    font-family: '.esc_html($carpenter_workshop_body_font_family).';
		}
		h1{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		h2{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		h3{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		h4{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		h5{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		h6{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		#theme-sidebar .wp-block-search .wp-block-search__label{
		    font-family: '.esc_html($carpenter_workshop_heading_font_family).';
		}
		.main-navigation a{
		    font-family: '.esc_html($carpenter_workshop_menu_font_family).';
		}
	';
	wp_add_inline_style('carpenter-workshop-style', $carpenter_workshop_tp_theme_css);
}
add_action( 'wp_enqueue_scripts', 'carpenter_workshop_scripts' );

/*radio button sanitization*/
function carpenter_workshop_sanitize_choices( $input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}

function carpenter_workshop_sanitize_select( $input, $setting ){
    $input = sanitize_key($input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}


// Sanitize Sortable control.
function carpenter_workshop_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$carpenter_workshop_sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$carpenter_workshop_sanitized_value[] = esc_attr( $item );
		}
	}
	return $carpenter_workshop_sanitized_value;
}
/* Excerpt Limit Begin */
function carpenter_workshop_excerpt_function($excerpt_count = 35) {
    $carpenter_workshop_excerpt = get_the_excerpt();

    $CARPENTER_WORKSHOP_TEXT_excerpt = wp_strip_all_tags($carpenter_workshop_excerpt);

    $carpenter_workshop_excerpt_limit = esc_attr(get_theme_mod('carpenter_workshop_excerpt_count', $excerpt_count));

    $carpenter_workshop_theme_excerpt = implode(' ', array_slice(explode(' ', $CARPENTER_WORKSHOP_TEXT_excerpt), 0, $carpenter_workshop_excerpt_limit));

    return $carpenter_workshop_theme_excerpt;
}
// Change number or products per row to 3
add_filter('loop_shop_columns', 'carpenter_workshop_loop_columns');
if (!function_exists('carpenter_workshop_loop_columns')) {
	function carpenter_workshop_loop_columns() {
		$carpenter_workshop_columns = get_theme_mod( 'carpenter_workshop_per_columns', 3 );
		return $carpenter_workshop_columns;
	}
}

//Change number of products that are displayed per page (shop page)
add_filter( 'loop_shop_per_page', 'carpenter_workshop_per_page', 20 );
function carpenter_workshop_per_page( $carpenter_workshop_cols ) {
  	$carpenter_workshop_cols = get_theme_mod( 'carpenter_workshop_product_per_page', 9 );
	return $carpenter_workshop_cols;
}

function carpenter_workshop_sanitize_checkbox( $input ) {
	// Boolean check
	return ( ( isset( $input ) && true == $input ) ? true : false );
}

function carpenter_workshop_sanitize_number_absint( $number, $setting ) {
	// Ensure $number is an absolute integer (whole number, zero or greater).
	$number = absint( $number );

	// If the input is an absolute integer, return it; otherwise, return the default
	return ( $number ? $number : $setting->default );
}

function carpenter_workshop_string_limit_words($string, $word_limit) {
    $words = explode(' ', $string);
    return implode(' ', array_slice($words, 0, $word_limit));
}

function carpenter_workshop_sanitize_number_range( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}

/**
 * Use front-page.php when Front page displays is set to a static page.
 */
function carpenter_workshop_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'carpenter_workshop_front_page_template' );

/**
 * Logo Custamization.
 */

function carpenter_workshop_logo_width(){

	$carpenter_workshop_logo_width   = get_theme_mod( 'carpenter_workshop_logo_width', 150 );

	echo "<style type='text/css' media='all'>"; ?>
		img.custom-logo{
		    width: <?php echo absint( $carpenter_workshop_logo_width ); ?>px;
		    max-width: 100%;
		}
	<?php echo "</style>";
}

add_action( 'wp_head', 'carpenter_workshop_logo_width' );

function carpenter_workshop_theme_setup() {

	define('CARPENTER_WORKSHOP_CREDIT',__('https://www.themespride.com/products/free-carpenter-wordpress-theme','carpenter-workshop') );
	if ( ! function_exists( 'carpenter_workshop_credit' ) ) {
		function carpenter_workshop_credit(){
			echo "<a href=".esc_url(CARPENTER_WORKSHOP_CREDIT)." target='_blank'>".esc_html__(get_theme_mod('carpenter_workshop_footer_text',__('Carpenter Workshop WordPress Theme','carpenter-workshop')))."</a>";
		}
	}

	/**
	 * Custom template tags for this theme.
	 */
	require get_parent_theme_file_path( '/inc/template-tags.php' );

	/**
	 * Additional features to allow styling of the templates.
	 */
	require get_parent_theme_file_path( '/inc/template-functions.php' );

	/**
	 * Customizer additions.
	 */
	require get_parent_theme_file_path( '/inc/customizer.php' );

	/**
	 * Load Theme About Page
	 */
	require get_parent_theme_file_path( '/inc/about-theme.php' );

	/**
	 * Load Theme Web File
	 */
	require get_parent_theme_file_path('/inc/wptt-webfont-loader.php' );
	/**
	 * Load Toggle file
	 */
	require get_parent_theme_file_path( '/inc/controls/customize-control-toggle.php' );
	/**
	 * load sortable file
	 */
	require get_parent_theme_file_path( '/inc/controls/sortable-control.php' );

	/**
	 * TGM Recommendation
	 */
	require get_parent_theme_file_path( '/inc/TGM/tgm.php' );

}
add_action( 'after_setup_theme', 'carpenter_workshop_theme_setup' );


// Hook to display the sale percentage on both product pages and shop loop
add_action('woocommerce_before_shop_loop_item_title', 'carpenter_workshop_ts_show_sale_percentage', 25);
add_action('woocommerce_before_single_product_summary', 'carpenter_workshop_ts_show_sale_percentage', 25);

function carpenter_workshop_ts_show_sale_percentage() {
global $product;
$carpenter_workshop_max_percentage = 0; // Initialize $carpenter_workshop_max_percentage here

if (!$product->is_on_sale()) return;

if ($product->is_type('simple')) {
$carpenter_workshop_max_percentage = (($product->get_regular_price() - $product->get_sale_price()) / $product->get_regular_price()) * 100;
} elseif ($product->is_type('variable')) {
foreach ($product->get_children() as $child_id) {
$carpenter_workshop_variation = wc_get_product($child_id);
$carpenter_workshop_price = $carpenter_workshop_variation->get_regular_price();
$carpenter_workshop_sale = $carpenter_workshop_variation->get_sale_price();
$carpenter_workshop_percentage = 0; // Initialize $carpenter_workshop_percentage here

if ($carpenter_workshop_price != 0 && !empty($carpenter_workshop_sale)) {
$carpenter_workshop_percentage = ($carpenter_workshop_price - $carpenter_workshop_sale) / $carpenter_workshop_price * 100;
}

if ($carpenter_workshop_percentage > $carpenter_workshop_max_percentage) {
$carpenter_workshop_max_percentage = $carpenter_workshop_percentage;
}
}
}

if ($product->is_type('grouped')) {
return; // Skip grouped products
}

if ($carpenter_workshop_max_percentage > 0) echo "<div class='percentage_badge'><div class='sale-perc'>" . round($carpenter_workshop_max_percentage) . "% Off</div></div>";
}


//Admin Enqueue for Admin
function carpenter_workshop_admin_enqueue_scripts(){
	wp_enqueue_style('carpenter-workshop-admin-style', get_template_directory_uri() . '/assets/css/admin.css');
	wp_register_script( 'carpenter-workshop-admin-script', get_template_directory_uri() . '/assets/js/carpenter-workshop-admin.js', array( 'jquery' ), '', true );

	wp_localize_script(
		'carpenter-workshop-admin-script',
		'carpenter_workshop',
		array(
			'admin_ajax'	=>	admin_url('admin-ajax.php'),
			'wpnonce'			=>	wp_create_nonce('carpenter_workshop_dismissed_notice_nonce')
		)
	);
	wp_enqueue_script('carpenter-workshop-admin-script');

    wp_localize_script( 'carpenter-workshop-admin-script', 'carpenter_workshop_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
}
add_action( 'admin_enqueue_scripts', 'carpenter_workshop_admin_enqueue_scripts' );

// get started
add_action( 'wp_ajax_carpenter_workshop_dismissed_notice_handler', 'carpenter_workshop_ajax_notice_handler' );

function carpenter_workshop_ajax_notice_handler() {
	if (!wp_verify_nonce($_POST['wpnonce'], 'carpenter_workshop_dismissed_notice_nonce')) {
		exit;
	}
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}

function carpenter_workshop_activation_notice() { 

	if ( ! get_option('dismissed-get_started', FALSE ) ) { ?>

    <div class="carpenter-workshop-notice-wrapper updated notice notice-get-started-class is-dismissible" data-notice="get_started">
        <div class="carpenter-workshop-getting-started-notice clearfix">
        	<div class="row-top">
	            <div class="carpenter-workshop-theme-notice-content">
	                <h2 class="carpenter-workshop-notice-h2">
	                    <?php
	                printf(
	                /* translators: 1: welcome page link starting html tag, 2: welcome page link ending html tag. */
	                    esc_html__( 'Install the Demo Import Plugin now to instantly set up your site like the live preview.', 'carpenter-workshop' ), '<strong>'. wp_get_theme()->get('Name'). '</strong>' );
	                ?>
	                </h2>
	                <a class="carpenter-workshop-btn-get-started button button-primary button-hero carpenter-workshop-button-padding" href="<?php echo esc_url( admin_url( 'themes.php?page=carpenter-workshop-about' )); ?>" ><?php esc_html_e( 'Get Started with Carpenter Workshop Theme', 'carpenter-workshop' ) ?></a>
	            </div>
	            <div class="image-box">
			    	<img src="<?php echo esc_url( get_template_directory_uri() . '/assets/images/theme-notice.png' ); ?>" alt="<?php echo esc_attr__( 'Carpenter Workshop', 'carpenter-workshop' ); ?>" />
				</div>
	        </div>
        </div>
    </div>
<?php }

}
add_action( 'admin_notices', 'carpenter_workshop_activation_notice' );

add_action('after_switch_theme', 'carpenter_workshop_setup_options');
function carpenter_workshop_setup_options () {
    update_option('dismissed-get_started', FALSE );
}

// Get Started Detail Notice - Dismiss permanently
function carpenter_workshop_dismissed_get_started_detail_notice() {
    update_option( 'dismissed-get_started-detail', true );
    wp_send_json_success();
}
add_action( 'wp_ajax_carpenter_workshop_dismissed_get_started_detail_notice', 'carpenter_workshop_dismissed_get_started_detail_notice' );
add_action( 'wp_ajax_nopriv_carpenter_workshop_dismissed_get_started_detail_notice', 'carpenter_workshop_dismissed_get_started_detail_notice' );

// Reset on theme switch
add_action('after_switch_theme', 'carpenter_workshop_setup_settings');
function carpenter_workshop_setup_settings() {
    update_option('dismissed-get_started', false );
    update_option('dismissed-get_started-detail', false );
}

add_action( 'wp_ajax_carpenter_workshop_popup_done', 'carpenter_workshop_popup_done' );
function carpenter_workshop_popup_done() {
	update_option( 'carpenter_workshop_demo_popup_shown', true );
	wp_die();
}